/*
 * Copyright (C) 2013-2018 MNEMOTIX <http://www.mnemotix.com/> and/or its affiliates
 * and other contributors as indicated by the @author tags.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

export class GraphMiddleware {
  /** @type {SynaptixDatastoreRdfSession} */
  _datastoreSession;

  /**
   *
   * @param {SynaptixDatastoreRdfSession} datastoreSession
   */
  attachSession(datastoreSession){
    this._datastoreSession = datastoreSession;
  }

  /**
   * @param {typeof ModelDefinitionAbstract} modelDefinition
   * @param {object} objectInput
   * @param {Link[]} [links]
   * @param {Link[]} [extraLinks] -   List of extra links autogenerated by middlewares.
   *
   * @return {Promise<{links: *[], extraLinks: *[], objectInput: {}}>}
   */
  async handleObjectCreation({modelDefinition, objectInput = {}, links = [], extraLinks = []}){
    return {objectInput, links, extraLinks};
  }

  /**
   * @param {typeof ModelDefinitionAbstract} modelDefinition
   * @param {object} objectInput
   * @param {Link[]} [links]
   * @param {Link[]} [extraLinks] -   List of extra links autogenerated by middlewares.
   *
   * @return {Promise<{links: *[], extraLinks: *[], objectInput: {}}>}
   */
  async handleObjectUpdate({modelDefinition, objectInput = {}, links = [], extraLinks = []}){
    return {objectInput, links, extraLinks};
  }

  /**
   * @param {typeof ModelDefinitionAbstract} modelDefinition
   * @param {object} objectInput
   * @param {Link[]} [links]
   * @param {Link[]} [extraLinks] -   List of extra links autogenerated by middlewares.
   *
   * @return {Promise<{links: *[], extraLinks: *[], objectInput: {}}>}
   */
  async handleObjectDeletion({modelDefinition, objectInput = {}, links = [], extraLinks = []}){
    return {objectInput, links, extraLinks};
  }

  /**
   * @param {typeof ModelDefinitionAbstract} modelDefinition
   * @param {PropertyFilter[]} [propertyFilters] -  List of property filters
   * @param {LinkFilter[]} [mustExistLinkFilters] -  List of link filters
   * @param {LinkFilter[]} [mustNotExistLinkFilters] -  List of link filters
   * @returns {Promise<{propertyFilters: PropertyFilter[], mustExistLinkFilters: LinkFilter[], mustNotExistLinkFilters: LinkFilter[]}>}
*/
  async handleObjectQuery({modelDefinition, propertyFilters, mustExistLinkFilters, mustNotExistLinkFilters}) {
    return {propertyFilters, mustExistLinkFilters, mustNotExistLinkFilters};
  }
}